unit uFacturas;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  HardLockServer_TLB,
  XTango_GV_TLB,
  ADODB_TLB,
  StdCtrls,
  ComCtrls,
  ExtCtrls,
  Grids,
  ImgList,
  ToolWin,
  ComObj,
  Variants, DB, ADODB, DBGrids;


type
  TForm1 = class(TForm)
    Panel1: TPanel;
    BtnFacCtaCte: TButton;
    BtnDesloguear: TButton;
    Factura: TPageControl;
    Encabezado: TTabSheet;
    Renglones: TTabSheet;
    Impuestos: TTabSheet;
    Cuotas: TTabSheet;
    EncabezadoFo: TTabSheet;
    RenglonesFo: TTabSheet;
    ToolBar1: TToolBar;
    BtnFacContado: TButton;
    Reporte_: TTabSheet;
    CBxUsaDefectos: TCheckBox;
    Panel2: TPanel;
    EdtLlave: TEdit;
    EdtUser: TEdit;
    EdtCompany: TEdit;
    Label28: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    BtnLogueo: TButton;
    DBGridFacturaEncabezado: TDBGrid;
    ADOEncabezadoFactura: TADODataSet;
    dtsEncabezadoFactura: TDataSource;
    ADORenglonesFactura: TADODataSet;
    ADOImpuestos: TADODataSet;
    ADOEncabezadoFondos: TADODataSet;
    ADOReporte: TADODataSet;
    ADORenglonesFondo: TADODataSet;
    dtsRenglonesFactura: TDataSource;
    dtsImpuestos: TDataSource;
    dtsEncabezadoFondos: TDataSource;
    dtsRenglonesFondos: TDataSource;
    dtsReporte: TDataSource;
    DBGridFacturaRenglones: TDBGrid;
    DBGridEncabezadoFondos: TDBGrid;
    DBGridCuotas: TDBGrid;
    DBGridImpuestos: TDBGrid;
    DBGridRenglonesFondos: TDBGrid;
    DBGridReportes: TDBGrid;
    dtsCuotas: TDataSource;
    ADOCuotas: TADODataSet;
    Exportacion: TTabSheet;
    DBGridExportacion: TDBGrid;
    dtsExportacion: TDataSource;
    ADOExportacion: TADODataSet;
    ChxFacElec: TCheckBox;
    ADOEmbarques: TADODataSet;
    dtsEmbarques: TDataSource;
    Embarque: TTabSheet;
    DBGridEmbarque: TDBGrid;
    BtnReconEstruc: TButton;
    btnGuardar: TButton;
    btnCargar: TButton;
    procedure ReconstruirEstructuras(Logueo: ILogon);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnDesloguearClick(Sender: TObject);
    procedure StringGrid4KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    function  LimpiarRecordset(var RsSource : OleVariant): _RecordSet;

    procedure BtnFacCtaCteClick(Sender: TObject);
    procedure BtnFacContadoClick(Sender: TObject);
    procedure TBtnLoadDefectosClick(Sender: TObject);
    procedure TBtnLogueoClick(Sender: TObject);
    procedure BtnLogueoClick(Sender: TObject);
    procedure FacturaContado(DefectosCliente, EsContado : Boolean);
    procedure ChxFacElecClick(Sender: TObject);
    procedure BtnReconEstrucClick(Sender: TObject);
    procedure btnGuardarClick(Sender: TObject);
    procedure btnCargarClick(Sender: TObject);
  private
    DirXML : string;
    procedure Inicializacion;
    procedure HabilitaControles(Estado : boolean);
    procedure OpenLogon;
    procedure CloseLogon;
    function  ExisteDirectorioXML() : Boolean;
    function  ExistenArchivosXML() : Boolean;
    procedure CrearDirectorioXML();


    function ExisteXML(FileName : string; ConMensaje : boolean) : boolean;
    { Private declarations }
  public
    { Public declarations }
  end;


const

  STR_FacturaEncabezado = 'FacEnc_STR.xml';
  STR_FacturaRenglones  = 'FacRen_STR.xml';
  STR_Impuestos         = 'Impu_STR.xml';
  STR_Cuotas            = 'Cuotas_STR.xml';
  STR_FondosEncabezado  = 'FonEnc_Str.xml';
  STR_FondosRenglones   = 'FonRen_Str.xml';
  STR_Exportacion       = 'Exporta_STR.xml';
  STR_Embarque          = 'Embarq_STR.xml';

  DEF_FacturaEncabezado = 'FacEnc.xml';
  DEF_FacturaRenglones  = 'FacRen.xml';
  DEF_Impuestos         = 'Impu.xml';
  DEF_Cuotas            = 'Cuotas.xml';
  DEF_FondosEncabezado  = 'FonEnc.xml';
  DEF_FondosRenglones   = 'FonRen.xml';
  DEF_Exportacion       = 'Exporta.xml';
  DEF_Embarque          = 'Embarq.xml';


  DEF_Resultados        = 'Resultados.xml';

  DIR_XML               = 'XML\';



var
  Form1    : TForm1;
  RutaXML  : String;
  RutaBase : String;    

implementation

{$R *.DFM}

var
  Logueo             : iLogon;
  Comprobante        : IComprobantes;
  RsFacEncabezado    : OleVariant;
  RsFacRenglones     : OleVariant;
  RsFacImpuestos     : OleVariant;
  RsFacCuotas        : OleVariant;
  RsFondosEncabezado : OleVariant;
  RsFondosRenglones  : OleVariant;
  RsExportacion      : OleVariant;
  RsEmbarques        : OleVariant;
  Reporte            : OleVariant;


procedure TForm1.CloseLogon;
begin
  if assigned(Logueo) then begin
    Logueo.DropInterface;
    Logueo := nil;
  end;
end;


procedure TForm1.OpenLogon;
begin
  try
    Logueo := CoLogOn.Create;

//****Asi es el logueo oculto (debo setear el user, la password y la company):****
//    if not Logueo.LogServerUserEx(EdtLlave.Text,
//                              EdtUser.Text,
//                              '',
//                              EdtCompany.Text,
//                              ExtractFilePath(Application.ExeName),
//                              Erro) then begin
//********************************************************************************

    if not Logueo.LogServerUser(EdtLlave.Text, EdtUser.Text, EdtCompany.Text,
                            ExtractFilePath(Application.ExeName),
                            Application.Handle) then begin
      ShowMessage('No se ha podido loguear, por favor verifique su conexin.');
      CloseLogon;
    end;
  except
    Dialogs.ShowMessage('Error al loguearse');
  end;
end;

function GetRecordsetFromVariant(const TheVariant:OleVariant):_Recordset;
var
  TmpType:word;
  TheRecordset: _RecordsetDisp;
  vData: TVarData;
begin
  vData := FindVarData(TheVariant)^;
  TmpType := vData.VType;
  if TmpType = varDispatch then begin
    TheRecordset := _RecordsetDisp(vData.VDispatch);
    GetRecordsetFromVariant := _Recordset( TheRecordset as Recordset );
  end else if TmpType = (varDispatch + varByRef) then begin
    GetRecordsetFromVariant := IDispatch(vData.VPointer^) as _Recordset;
  end else if TmpType = varUnknown then begin
    GetRecordsetFromVariant := _Recordset(vData.VUnknown);
  end else begin
    GetRecordsetFromVariant := nil;
  end;
end;

function TForm1.ExisteDirectorioXML() : Boolean;
begin
  if Not DirectoryExists(RutaXML) then
    Result := False
  else
    Result := True;
end;

procedure TForm1.CrearDirectorioXML();
begin
  CreateDir(RutaXML);
end;


function TForm1.ExistenArchivosXML() : Boolean;
begin
  if not FileExists(RutaXML + DEF_FacturaEncabezado) or
     not FileExists(RutaXML + DEF_FacturaRenglones)  or
     not FileExists(RutaXML + DEF_Impuestos)         or
     not FileExists(RutaXML + DEF_Cuotas)            or
     not FileExists(RutaXML + DEF_FondosEncabezado)  or
     not FileExists(RutaXML + DEF_FondosRenglones)   or
     not FileExists(RutaXML + DEF_Exportacion)       or
     not FileExists(RutaXML + DEF_Embarque)          then
    Result := False
  else
    Result := True;
end;


procedure TForm1.ReconstruirEstructuras(Logueo: ILogon);
var
  ok : Boolean;
begin
  ok := False;
  if Assigned(Comprobante) then
    Comprobante := nil;
  try
    Comprobante := CoComprobantes.Create;
    if not Comprobante.Make_FacEncabezado(Logueo, RsFacEncabezado) then
      ShowMessage('Fallo el metodo Make_FacEncabezado')
    else if not Comprobante.Make_FacRenglones(Logueo, RsFacRenglones) then
      ShowMessage('Fallo el metodo Make_FacRenglones')
    else if not Comprobante.Make_FacImpuestos(Logueo, RsFacImpuestos) then
      ShowMessage('Fallo el metodo Make_FacImpuestos')
    else if not Comprobante.Make_FacCuotas(Logueo, RsFacCuotas) then
      ShowMessage('Fallo el metodo Make_FacCuotas')
    else if not Comprobante.Make_FondosEncabezado(Logueo, RsFondosEncabezado) then
      ShowMessage('Fallo el metodo Make_FondosEncabezado')
    else if not Comprobante.Make_FondosRenglones(Logueo, RsFondosRenglones) then
      ShowMessage('Fallo el metodo Make_FondosRenglones')
    else if not Comprobante.Make_DatosExportacion(Logueo, RsExportacion) then
      ShowMessage('Fallo el metodo Make_DatosExportacion')
    else if not Comprobante.Make_PermisosEmbarque(Logueo, RsEmbarques) then
      ShowMessage('Fallo el metodo Make_DatosExportacion')
    else
      ok := True;
    if ok then begin
      ADOEncabezadoFactura.Recordset := GetRecordsetFromVariant(RsFacEncabezado);
      ADORenglonesFactura.Recordset  := GetRecordsetFromVariant(RsFacRenglones);
      ADOImpuestos.Recordset         := GetRecordsetFromVariant(RsFacImpuestos);
      ADOCuotas.Recordset            := GetRecordsetFromVariant(RsFacCuotas);
      ADOEncabezadoFondos.Recordset  := GetRecordsetFromVariant(RsFondosEncabezado);
      ADORenglonesFondo.Recordset    := GetRecordsetFromVariant(RsFondosRenglones);
      ADOExportacion.Recordset       := GetRecordsetFromVariant(RsExportacion);
      ADOEmbarques.Recordset         := GetRecordsetFromVariant(RsEmbarques);

      ADOEncabezadoFactura.SaveToFile(RutaXML + STR_FacturaEncabezado, pfXML);
      ADORenglonesFactura.SaveToFile (RutaXML + STR_FacturaRenglones , pfXML);
      ADOImpuestos.SaveToFile        (RutaXML + STR_Impuestos        , pfXML);
      ADOCuotas.SaveToFile           (RutaXML + STR_Cuotas           , pfXML);
      ADOEncabezadoFondos.SaveToFile (RutaXML + STR_FondosEncabezado , pfXML);
      ADORenglonesFondo.SaveToFile   (RutaXML + STR_FondosRenglones  , pfXML);
      ADOExportacion.SaveToFile      (RutaXML + STR_Exportacion      , pfXML);
      ADOEmbarques.SaveToFile        (RutaXML + STR_Embarque         , pfXML);
    end;

    Comprobante := nIL

  except
    ShowMessage('Error al instanciar IComprobantes');
    Comprobante := nil;
  end;

end;


procedure TForm1.Inicializacion;

var
  B : boolean;
begin
  try

    CloseLogon;
    OpenLogon;
    ReconstruirEstructuras(Logueo);
    B := true;
  except
    B := false;
    CloseLogon;
  end;
  HabilitaControles(B);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  Factura.ActivePage := Encabezado;
  HabilitaControles(False);

  DirXML := ExtractFilePath(Application.ExeName);

  // Setea las rutas de los archivos XML y de la Aplicacion
  RutaBase                     := IncludeTrailingPathDelimiter(ExtractFilePath(Application.ExeName));
  RutaXML                      := RutaBase + DIR_XML;
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  if assigned(Logueo) then begin
    Comprobante         := nil;
    Logueo.DropInterface;
    Logueo              := nil;

    RsFacEncabezado     := unassigned;
    RsFacRenglones      := unassigned;
    RsFacImpuestos      := unassigned;
    RsFacCuotas         := unassigned;
    RsFondosEncabezado  := unassigned;
    RsFondosRenglones   := unassigned;
    RsExportacion       := unassigned;
    RsEmbarques         := unassigned;
  end;
end;


procedure TForm1.btnCargarClick(Sender: TObject);
begin
  if Not ExistenArchivosXML then begin
    ShowMessage('No se puede Cargar - Archivos XML no encontrados');
    exit;
  end;

  try
      // trae los datos del XML y los trae al global

      RsFacEncabezado := CoRecordset.Create;
      RsFacEncabezado.Open(RutaXML + DEF_FacturaEncabezado, EmptyParam, adOpenDynamic, adOpenDynamic, 0);
      ADOEncabezadoFactura.Recordset := GetRecordsetFromVariant(RsFacEncabezado);


      RsFacRenglones := CoRecordset.Create;
      RsFacRenglones.Open(RutaXML + DEF_FacturaRenglones, EmptyParam, adOpenDynamic, adOpenDynamic, 0);
      ADORenglonesFactura.Recordset := GetRecordsetFromVariant(RsFacRenglones);


      RsFacImpuestos := CoRecordset.Create;
      RsFacImpuestos.Open(RutaXML + DEF_Impuestos, EmptyParam, adOpenDynamic, adOpenDynamic, 0);
      ADOImpuestos.Recordset := GetRecordsetFromVariant(RsFacImpuestos);


      RsFacCuotas := CoRecordset.Create;
      RsFacCuotas.Open(RutaXML + DEF_Cuotas, EmptyParam, adOpenDynamic, adOpenDynamic, 0);
      ADOCuotas.Recordset := GetRecordsetFromVariant(RsFacCuotas);

      RsFondosEncabezado := CoRecordset.Create;
      RsFondosEncabezado.Open(RutaXML + DEF_FondosEncabezado, EmptyParam, adOpenDynamic, adOpenDynamic, 0);
      ADOEncabezadoFondos.Recordset := GetRecordsetFromVariant(RsFondosEncabezado);

      RsFondosRenglones := CoRecordset.Create;
      RsFondosRenglones.Open(RutaXML + DEF_FondosRenglones, EmptyParam, adOpenDynamic, adOpenDynamic, 0);
      ADORenglonesFondo.Recordset := GetRecordsetFromVariant(RsFondosRenglones);

      RsExportacion := CoRecordset.Create;
      RsExportacion.Open(RutaXML + DEF_Exportacion, EmptyParam, adOpenDynamic, adOpenDynamic, 0);
      ADOExportacion.Recordset := GetRecordsetFromVariant(RsExportacion);

      RsEmbarques := CoRecordset.Create;
      RsEmbarques.Open(RutaXML + DEF_Embarque, EmptyParam, adOpenDynamic, adOpenDynamic, 0);
      ADOEmbarques.Recordset := GetRecordsetFromVariant(RsEmbarques);


      // Libera estructuras
      RsFacEncabezado    := unassigned;
      RsFacRenglones     := unassigned;
      RsFacImpuestos     := unassigned;
      RsFacCuotas        := unassigned;
      RsFondosEncabezado := unassigned;
      RsExportacion      := unassigned;
      RsEmbarques        := unassigned;

  except
   on E : Exception do
     MessageDlg('Error al cargar los datos (' + E.Message + ')', mtWarning, [mbOK], 0);
  end;
end;

procedure TForm1.BtnDesloguearClick(Sender: TObject);
begin
  if assigned(Logueo) then begin
    Comprobante         := nil;
    Logueo.DropInterface;
    Logueo              := nil;

    RsFacEncabezado     := unassigned;
    RsFacRenglones      := unassigned;
    RsFacImpuestos      := unassigned;
    RsFacCuotas         := unassigned;
    RsFondosEncabezado  := unassigned;
    RsFondosRenglones   := unassigned;
    HabilitaControles(False);
  end;
end;


procedure TForm1.StringGrid4KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i, j,k : integer;
begin
  if (Key = 13) and   //Enter
     ((Sender as TStringGrid).Row = (Sender as TStringGrid).Rowcount-1) then begin
     j := (Sender as TStringGrid).Rowcount;
    (Sender as TStringGrid).Rowcount := j + 1;
    (Sender as TStringGrid).Cells[0,j] := intToStr(j);
    (Sender as TStringGrid).Refresh;
  end
  else if (Key = 113) then begin   //F2
    k := (Sender as TStringGrid).Row;
    for i := k to (Sender as TStringGrid).Rowcount do
      for j := 1 to (Sender as TStringGrid).Colcount do
        (Sender as TStringGrid).Cells[j, i] := (Sender as TStringGrid).Cells[j, i+1];
    i := (Sender as TStringGrid).Rowcount;
    if i > 2 then begin
      (Sender as TStringGrid).Rowcount := i - 1;
      (Sender as TStringGrid).Refresh;
    end;
  end
  else if (Key = 114) then begin   //F3
     k := (Sender as TStringGrid).Row;
     j := (Sender as TStringGrid).Rowcount;
    (Sender as TStringGrid).Rowcount := j + 1;
    (Sender as TStringGrid).Cells[0,j] := intToStr(j);
     for i := 1 to (Sender as TStringGrid).Colcount do
       (Sender as TStringGrid).Cells[i, j] := (Sender as TStringGrid).Cells[i, k];
    (Sender as TStringGrid).Refresh;
  end;
end;


procedure TForm1.FacturaContado(DefectosCliente, EsContado : Boolean);
var
  RSFacturaEncabezado ,
  RSFacturaRenglones  ,
  RSFondosEncabezado  ,
  RSFondosRenglones   ,
  RSCuotas            ,
  RSImpuestos         ,
  RSResultados        : OleVariant;
  B                   : Boolean;
begin
  try
    Comprobante := CoComprobantes.Create;

    // Toma los datos de los recordsets globales
    RSFacturaEncabezado := ADOEncabezadoFactura.Recordset;
    RSFacturaRenglones  := ADORenglonesFactura.Recordset ;
    RSFondosEncabezado  := ADOEncabezadoFondos.Recordset ;
    RSFondosRenglones   := ADORenglonesFondo.Recordset   ;
    RSImpuestos         := ADOImpuestos.Recordset        ;
    RSCuotas            := ADOCuotas.Recordset           ;
    RsExportacion       := ADOExportacion.Recordset      ;
    RsEmbarques         := ADOEmbarques.Recordset        ; 
    RSResultados        := Unassigned                    ;
    if not ChxFacElec.Checked then begin
      if EsContado then
        B := Comprobante.Add_FacturaContado(Logueo,
                               RSFacturaEncabezado,
                               RSFacturaRenglones,
                               RSImpuestos,
                               RSFondosEncabezado,
                               RSFondosRenglones,
                               DefectosCliente,
                               RSResultados)
      else
        B := Comprobante.Add_FacturaCtaCorriente(Logueo,
                               RSFacturaEncabezado,
                               RSFacturaRenglones,
                               RSImpuestos,
                               RSCuotas,
                               DefectosCliente,
                               RSResultados);
    end
    else begin
      if EsContado then
        B := Comprobante.Add_FacturaExportacionContado(Logueo,
                             RSFacturaEncabezado,
                             RSFacturaRenglones,
                             RSImpuestos,
                             RSFondosEncabezado,
                             RSFondosRenglones,
                             RsEmbarques,
                             RsExportacion,
                             DefectosCliente,
                             RSResultados)
      else
        B := Comprobante.Add_FacturaExportacionCtaCorriente(Logueo,
                             RSFacturaEncabezado,
                             RSFacturaRenglones,
                             RSImpuestos,
                             RSCuotas,
                             RsEmbarques,
                             RsExportacion,
                             DefectosCliente,
                             RSResultados);

    end;


    if not VarisEmpty(RSResultados) then begin
      ADOReporte.Recordset := GetRecordsetFromVariant(RSResultados);
      Factura.ActivePageIndex := 8;
    end;

    // Libera estructuras
    Comprobante         := Nil;
    RSFacturaEncabezado := Unassigned;
    RSFacturaRenglones  := Unassigned;
    RSFondosEncabezado  := Unassigned;
    RSFondosRenglones   := Unassigned;
    RSImpuestos         := Unassigned;
    RsExportacion       := Unassigned;
    RsEmbarques         := Unassigned;
    RSResultados        := Unassigned;

   except
    on E : Exception do
      MessageDlg('Fall el ingreso de Recibos (' + E.Message + ')', mtWarning, [mbOK], 0);
   end;
end;


procedure TForm1.BtnFacCtaCteClick(Sender: TObject);
begin
  FacturaContado(CBxUsaDefectos.Checked, False);
end;

procedure TForm1.btnGuardarClick(Sender: TObject);
begin

  if not ExisteDirectorioXML then
    CrearDirectorioXML;
  ADOEncabezadoFactura.SaveToFile(RutaXML + DEF_FacturaEncabezado, pfXML);
  ADORenglonesFactura.SaveToFile (RutaXML + DEF_FacturaRenglones , pfXML);
  ADOImpuestos.SaveToFile        (RutaXML + DEF_Impuestos        , pfXML);
  ADOCuotas.SaveToFile           (RutaXML + DEF_Cuotas           , pfXML);
  ADOEncabezadoFondos.SaveToFile (RutaXML + DEF_FondosEncabezado , pfXML);
  ADORenglonesFondo.SaveToFile   (RutaXML + DEF_FondosRenglones  , pfXML);
  ADOExportacion.SaveToFile      (RutaXML + DEF_Exportacion      , pfXML);
  ADOEmbarques.SaveToFile        (RutaXML + DEF_Embarque         , pfXML);
end;

procedure TForm1.BtnFacContadoClick(Sender: TObject);
begin
  FacturaContado(CBxUsaDefectos.Checked, True);
end;


function TForm1.LimpiarRecordset(var RsSource : OleVariant): _RecordSet;
var
  stream   : Olevariant;
  ORsNew   : OleVariant;
  OrsSource: Olevariant;
begin
  stream := CreateOleObject('Adodb.stream');
  stream.Open(emptyparam,emptyparam, emptyparam,
                   emptyparam, emptyparam);

  ORsSource := Idispatch(RsSource) as _RecordSet;

  // cuando XML soporte recordset modificados cambiar adPersistAdtg por xml
  ORsSource.Filter := '[ID_Comp] < 0';
  ORsSource.Save(stream, adPersistAdtg);
  ORsSource.Filter := adFilterNone;
  OrsNew := coRecordset.create;
  OrsNew.Open( Stream, emptyparam, adOpenKeySet, adLockBatchOptimistic, 0);

  Result := IDispatch(OrsNew) as _Recordset;
end;

procedure TForm1.TBtnLoadDefectosClick(Sender: TObject);
begin
  if ExisteXML('FacCuo.xml', false) and ExisteXML('FacEnc.xml', false) and
     ExisteXML('FacImp.xml', false) and ExisteXML('FacRen.xml', false) and
     ExisteXML('FonEnc.xml', false) and ExisteXML('FonRen.xml', false) then begin
//    AbrirEncabezado  ('FacEnc.xml');
//    AbrirRenglones   ('FacRen.xml');
//    AbrirImpuestos   ('FacImp.xml');
//    AbrirCuotas      ('FacCuo.xml');
//    AbrirEncabezadoFo('FonEnc.xml');
//    AbrirRenglonesFo ('FonRen.xml');
  end
  else
    ShowMessage('Verifique que en el directorio por defecto existan los siguientes archivos: '+ #13+
     'FacCuo.xml' +#13+
     'FacEnc.xml' +#13+
     'FacImp.xml' +#13+
     'FacRen.xml' +#13+
     'FonEnc.xml' +#13+
     'FonRen.xml' +#13);
end;

procedure TForm1.ChxFacElecClick(Sender: TObject);
begin
  DBGridExportacion.Enabled := ChxFacElec.Checked;
  DBGridEmbarque.Enabled    := ChxFacElec.Checked;
end;

procedure TForm1.TBtnLogueoClick(Sender: TObject);
begin
  Inicializacion;
end;


procedure TForm1.HabilitaControles(Estado : boolean);
begin
  BtnReconEstruc.Enabled    := Estado;
  BtnFacCtaCte.Enabled      := Estado;
  BtnFacContado.Enabled     := Estado;
  ChxFacElec.Enabled        := Estado;
  Factura.Enabled           := Estado;
  BtnDesloguear.Enabled     := Estado;
  CBxUsaDefectos.Enabled    := Estado;
  btnGuardar.Enabled        := Estado;
  btnCargar.Enabled         := Estado;
  DBGridExportacion.Enabled := ChxFacElec.Checked;
  DBGridEmbarque.Enabled    := ChxFacElec.Checked;
  BtnLogueo.Enabled         := not Estado;
  EdtLlave.Enabled          := not Estado;
  EdtUser.Enabled           := not Estado;
  EdtCompany.Enabled        := not Estado;
end;


procedure TForm1.BtnLogueoClick(Sender: TObject);
begin
  Inicializacion;
end;

procedure TForm1.BtnReconEstrucClick(Sender: TObject);
begin
  if Assigned(Logueo) then
    ReconstruirEstructuras(Logueo)
  else
    ShowMessage('Debe loguearse primero');
end;

function TForm1.ExisteXML(FileName : string; ConMensaje : boolean): boolean;
var
  S : string;
begin
  S := ExtractFilePath(FileName);
  if S = '' then begin
    S := DirXML + FileName;
    FileName := S;
  end;
  result := FileExists(FileName);
  if not Result and ConMensaje then
    ShowMessage('El archivo no existe ('+FileName+')')
end;

end.
